# Create a plan

You can now model subscriptions more flexibly using the [Prices API](https://docs.stripe.com/api/plans/create.md#prices). It replaces the Plans API and is backwards compatible to simplify your migration.

## Prerequisites

Before you can run the following code snippet, you need to call these APIs with the provided parameters to set up the prerequisite API object(s).

1. createProduct
POST /v1/products {"name":"Gold Plan"}

## Request

```curl
curl https://api.stripe.com/v1/plans \
  -u "<<YOUR_SECRET_KEY>>" \
  -d amount=1200 \
  -d currency=usd \
  -d interval=month \
  -d product={{PRODUCT_ID}}
```

### Response

```json
{
  "id": "plan_NjpIbv3g3ZibnD",
  "object": "plan",
  "active": true,
  "amount": 1200,
  "amount_decimal": "1200",
  "billing_scheme": "per_unit",
  "created": 1681851647,
  "currency": "usd",
  "interval": "month",
  "interval_count": 1,
  "livemode": false,
  "metadata": {},
  "nickname": null,
  "product": "prod_NjpI7DbZx6AlWQ",
  "tiers_mode": null,
  "transform_usage": null,
  "trial_period_days": null,
  "usage_type": "licensed"
}
```

## Returns

Returns the plan object.

## Parameters

- `currency` (enum, required)
  Three-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://docs.stripe.com/currencies.md).

- `interval` (enum, required)
  Specifies billing frequency. Either `day`, `week`, `month` or `year`.
Possible enum values:
  - `day`
  - `month`
  - `week`
  - `year`

- [`product`](https://docs.stripe.com/api/plans/create.md?query=product) (object, required)
  The product whose pricing the created plan will represent. This can either be the ID of an existing product, or a dictionary containing fields used to create a [service product](https://docs.stripe.com/api.md#product_object-type).

- `active` (boolean, optional)
  Whether the plan is currently available for new subscriptions. Defaults to `true`.

- `amount` (integer, Required unless billing_scheme=tiered)
  A positive integer in the smallest currency unit (or 0 for a free plan) representing how much to charge on a recurring basis.

- `amount_decimal` (string, optional)
  Same as `amount`, but accepts a decimal value with at most 12 decimal places. Only one of `amount` and `amount_decimal` can be set.

- `billing_scheme` (enum, optional)
  Describes how to compute the price per period. Either `per_unit` or `tiered`. `per_unit` indicates that the fixed amount (specified in `amount`) will be charged per unit in `quantity` (for plans with `usage_type=licensed`), or per unit of total usage (for plans with `usage_type=metered`). `tiered` indicates that the unit pricing will be computed using a tiering strategy as defined using the `tiers` and `tiers_mode` attributes.
Possible enum values:
  - `per_unit`
  - `tiered`

- `id` (string, optional)
  An identifier randomly generated by Stripe. Used to identify this plan when subscribing a customer. You can optionally override this ID, but the ID must be unique across all plans in your Stripe account. You can, however, use the same plan ID in both live and test modes.

- `interval_count` (integer, optional)
  The number of intervals between subscription billings. For example, `interval=month` and `interval_count=3` bills every 3 months. Maximum of three years interval allowed (3 years, 36 months, or 156 weeks).

- `metadata` (map, optional)
  Set of [key-value pairs](https://docs.stripe.com/api/metadata.md) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to `metadata`.

- `meter` (string, optional)
  The meter tracking the usage of a metered price

- `nickname` (string, optional)
  A brief description of the plan, hidden from customers.

- [`tiers`](https://docs.stripe.com/api/plans/create.md?query=tiers) (array of objects, Required if billing_scheme=tiered)
  Each element represents a pricing tier. This parameter requires `billing_scheme` to be set to `tiered`. See also the documentation for `billing_scheme`.

- `tiers_mode` (enum, Required if billing_scheme=tiered)
  Defines if the tiering price should be `graduated` or `volume` based. In `volume`-based tiering, the maximum quantity within a period determines the per unit price, in `graduated` tiering pricing can successively change as the quantity grows.

- [`transform_usage`](https://docs.stripe.com/api/plans/create.md?query=transform_usage) (object, optional)
  Apply a transformation to the reported usage or set quantity before computing the billed price. Cannot be combined with `tiers`.

- `trial_period_days` (integer, optional)
  Default number of trial days when subscribing a customer to this plan using [`trial_from_plan=true`](https://docs.stripe.com/api.md#create_subscription-trial_from_plan).

- `usage_type` (enum, optional)
  Configures how the quantity per period should be determined. Can be either `metered` or `licensed`. `licensed` automatically bills the `quantity` set when adding it to a subscription. `metered` aggregates the total usage based on usage records. Defaults to `licensed`.
Possible enum values:
  - `licensed`
  - `metered`
